#include <stdio.h>
#include <stdlib.h>

#include "libsais.h"

int main(int argc, const char *argv[])
{
    FILE *fp;
    long flen;
    unsigned char *T;
    int *SA;
    int rc = 0;

    if (argc != 2) {
        fprintf(stderr, "Usage: %s [file]\n", argv[0]);
        return 1;
    }

    if ((fp = fopen(argv[1], "r")) == NULL) {
        perror("fopen");
        return 1;
    }

    if ((fseek(fp, 0, SEEK_END)) != 0) {
        perror("fseek");
        return 1;
    }

    if ((flen = ftell(fp)) < 0) {
        perror("ftell");
        return 1;
    }

    rewind(fp);

    T = malloc(flen * sizeof(*T));
    SA = malloc(flen * sizeof(*SA));

    if (T == NULL || SA == NULL) {
        fprintf(stderr, "memory allocation failed\n");
        return 1;
    }

    if ((fread(T, sizeof(*T), flen, fp)) != flen * sizeof(*T)) {
        fprintf(stderr, "fread - unexpected read length\n");
        free(T);
        free(SA);
        return 1;
    }

    if (libsais(T, SA, flen, 0) != 0) {
        fprintf(stderr, "libsais - error returned\n");
        rc = 1;
    }

    fclose(fp);
    free(T);
    free(SA);

    return rc;
}
